'------------------------------------------------------------------------
' vcdgermany.vbs - customizable releaselists from www.vcdgermnay.de
'------------------------------------------------------------------------


'=========================================================================
' VARIABLES TO CHANGE:
'=========================================================================

'=========================================================================
' The login for the site you want to get your data from
'=========================================================================
SITE_USER 	= "ENTER USERNAME HERE"
SITE_PASS 	= "ENTER PASSWORD HERE"
SITE_AUTH 	= SITE_USER & ":" & SITE_PASS & "@"

'=========================================================================

'=========================================================================
' Categories URLs
'=========================================================================
CAT_VCD 	= "http://" & SITE_AUTH & "www.vcdgermany.de/cms/list.php?genre=1"
CAT_SVCD 	= "http://" & SITE_AUTH & "www.vcdgermany.de/cms/list.php?genre=2"
CAT_MVCD 	= "http://" & SITE_AUTH & "www.vcdgermany.de/cms/list.php?genre=12"
CAT_DIVX 	= "http://" & SITE_AUTH & "www.vcdgermany.de/cms/list.php?genre=3"
CAT_DVDR 	= "http://" & SITE_AUTH & "www.vcdgermany.de/cms/list.php?genre=5"
CAT_APPS 	= "http://" & SITE_AUTH & "www.vcdgermany.de/cms/list.php?genre=6"
CAT_GAMES 	= "http://" & SITE_AUTH & "www.vcdgermany.de/cms/list.php?genre=7"
CAT_MISC 	= "http://" & SITE_AUTH & "www.vcdgermany.de/cms/listmixed.php"
'=========================================================================

'=========================================================================
' A string in the HTML source to verify that you have got the right page
' (eg. use the page title)
'=========================================================================
PAGE_CHECK 	= "<!-- <tr bgcolor=""#FFFFFF""> -->"
'=========================================================================

'=========================================================================
' String to search for first - to advance to a spot just before each 
' data item you want to extract. 
' (NOTE: text containing quote marks (") must have two " marks to signify
' a " in the text.)
'=========================================================================
DATE_CHECK 	= "<td width=""69"">"
CD_CHECK 	= "target=_blank><img src=""http://www.vcdgermany.de/cms/"          
RELEASE_CHECK 	= "<b><span class=""text""><a href=""artikel.php?id="
TYPE_CHECK 	= "<td width=""58"">"
RELEASER_CHECK 	= "<a href=""groups.php?"
GENRE_CHECK	= "<td width=""55""><span "
'=========================================================================

'=========================================================================
' String marking the end of all text before the text you are interested in
' (eg. if you were interested in the text of a hyperlink:
'
'         <a href="somesite">My Text</a> 
'
' you would set this to  "somesite"">" for example.
'=========================================================================
DATE_CHECK2 	= "class=""smallvcdg"">"
CD_CHECK2 	= "<img src=""cd" 
RELEASE_CHECK2 	= "title="""
TYPE_CHECK2 	= "class=""smallvcdg"">"
RELEASER_CHECK2 = "style=""font-weight:normal"">"
GENRE_CHECK2	= "class=""smallvcdg"">" & vbcrlf & vbcrlf
'=========================================================================

'=========================================================================
' String marking the end of the text you are interested in. eg. if you
' were interested in the text of a hyperlink:
'
'         <a href="somesite">My Text</a>
'
' you would set this to "</a>"
'=========================================================================
DATE_END 	= "</span></td>"
CD_END 		= ".gif"">"
RELEASE_END 	= """ style=""font-weight:normal"">"
TYPE_END 	= "</span></td>"
RELEASER_END 	= "</a><span></td>"
GENRE_END	= vbcrlf & vbcrlf & "</span></td>"
'=========================================================================




'=========================================================================
' DO NOT MODIFY ANYTHING PAST HERE UNLES YOU KNOW WHAT YOU ARE DOING!
'=========================================================================

Function Misc_Releases(Number_of_lines, Show_Date, Show_Amount_of_CDs, Show_Genre, Show_Type, Show_Releaser)
	 Misc_Releases = GetInfo(CAT_MISC, Number_of_lines, Show_Date, Show_Amount_of_CDs, Show_Genre, Show_Type, Show_Releaser) 
End Function

Function VCD_Releases(Number_of_lines, Show_Date, Show_Amount_of_CDs, Show_Genre, Show_Type, Show_Releaser)
	 VCD_Releases = GetInfo(CAT_VCD, Number_of_lines, Show_Date, Show_Amount_of_CDs, Show_Genre, Show_Type, Show_Releaser) 
End Function

Function SVCD_Releases(Number_of_lines, Show_Date, Show_Amount_of_CDs, Show_Genre, Show_Type, Show_Releaser)
	 SVCD_Releases = GetInfo(CAT_SVCD, Number_of_lines, Show_Date, Show_Amount_of_CDs, Show_Genre, Show_Type, Show_Releaser) 
End Function

Function MVCD_Releases(Number_of_lines, Show_Date, Show_Amount_of_CDs, Show_Genre, Show_Type, Show_Releaser)
	 MVCD_Releases = GetInfo(CAT_MVCD, Number_of_lines, Show_Date, Show_Amount_of_CDs, Show_Genre, Show_Type, Show_Releaser) 
End Function

Function DivX_Releases(Number_of_lines, Show_Date, Show_Amount_of_CDs, Show_Genre, Show_Type, Show_Releaser)
	 DivX_Releases = GetInfo(CAT_DIVX, Number_of_lines, Show_Date, Show_Amount_of_CDs, Show_Genre, Show_Type, Show_Releaser) 
End Function

Function DVDR_Releases(Number_of_lines, Show_Date, Show_Amount_of_CDs, Show_Genre, Show_Type, Show_Releaser)
	 DVDR_Releases = GetInfo(CAT_DVDR, Number_of_lines, Show_Date, Show_Amount_of_CDs, Show_Genre, Show_Type, Show_Releaser) 
End Function

Function Software_Releases(Number_of_lines, Show_Date, Show_Amount_of_CDs, Show_Genre, Show_Type, Show_Releaser)
	 Software_Releases = GetInfo(CAT_APPS, Number_of_lines, Show_Date, Show_Amount_of_CDs, Show_Genre, Show_Type, Show_Releaser) 
End Function

Function PCGames_Releases(Number_of_lines, Show_Date, Show_Amount_of_CDs, Show_Genre, Show_Type, Show_Releaser)
	 PCGames_Releases = GetInfo(CAT_GAMES, Number_of_lines, Show_Date, Show_Amount_of_CDs, Show_Genre, Show_Type, Show_Releaser) 
End Function


Private Function GetInfo(Cat_URL, Number_of_lines, Show_Date, Show_Amount_of_CDs, Show_Genre, Show_Type, Show_Releaser)		
	
	dim htmlResult,output
	' == Get HTML ==
	htmlResult = ReturnHTML(Cat_URL)
	output = ""
	
	' == Check Parameters ==
	If IsNumeric(Number_of_lines) Then
		If Number_of_lines < 1 OR Number_of_lines > 20 Then
			Number_of_lines = 5
		End If		
	Else
		Number_of_lines = 5
	End If

	If LCase(Show_Date) = "true" OR Show_Date = "1" Then
		Show_Date = 1
	Else
		Show_Date = 0
	End If

	If LCase(Show_Genre) = "true" OR Show_Genre = "1" Then
		Show_Genre = 1
	Else
		Show_Genre = 0
	End If
	
	If LCase(Show_Amount_of_CDs) = "true" OR Show_Amount_of_CDs = "1" Then
		Show_Amount_of_CDs = 1
	Else
		Show_Amount_of_CDs = 0
	End If

	If LCase(Show_Type) = "true" OR Show_Type = "1" Then
		Show_Type = 1
	Else
		Show_Type = 0
	End If
		
	If LCase(Show_Releaser) = "true" OR Show_Releaser = "1" Then
		Show_Releaser = 1
	Else
		Show_Releaser = 0
	End If
	
	
	startPos = instr(htmlResult, PAGE_CHECK)

	if startPos > 0 then

		While (Number_of_lines >= 1)

	                ' == Get Data From HTML ==

			'DATE
			If Show_Date > 0 Then                                                                      
				posOne = instr( startPos, htmlResult, DATE_CHECK)                                  
       				posOne = instr( posOne, htmlResult, DATE_CHECK2) + Len(DATE_CHECK2)	          
		                                                                                                  
				posTwo = instr( posOne, htmlResult, DATE_END)                                
		                                                                                                  
				If posOne > 0 AND posTwo > posOne Then                                            
					Item_Date = right(mid( htmlResult, posOne, posTwo-posOne ), posTwo-posOne) 
				End if                                                                            

				' new start position                                                              
				startPos = posTwo                                                                 
	                End If


			'TYPE
			If Show_Type > 0 Then                                                                      
				posOne = instr( startPos, htmlResult, TYPE_CHECK)                                  
       				posOne = instr( posOne, htmlResult, TYPE_CHECK2) + Len(TYPE_CHECK2)	          
		                                                                                                  
				posTwo = instr( posOne, htmlResult, TYPE_END)                                
		                                                                                                  
				If posOne > 0 AND posTwo > posOne Then                                            
					Item_Type = right(mid( htmlResult, posOne, posTwo-posOne ), posTwo-posOne) 
				End if                                                                            
		                
				' new start position                                                              
				startPos = posTwo                                                                 
	                End If

	                
	                'CDs
	                If Show_Amount_of_CDs > 0 Then
                
				posOne = instr( startPos, htmlResult, CD_CHECK)                                  
       				posOne = instr( posOne, htmlResult, CD_CHECK2) + Len(CD_CHECK2)	          
		                                                                                                  
				posTwo = instr( posOne, htmlResult, CD_END)                                
		                                                                                                  
				If posOne > 0 AND posTwo > posOne Then                                            
					Item_CDs = right(mid( htmlResult, posOne, posTwo-posOne ), posTwo-posOne) 
				End if                                                                            

			End If

			
			'RELEASENAME
			posOne = instr( startPos, htmlResult, RELEASE_CHECK)
			posOne = instr( posOne, htmlResult, RELEASE_CHECK2) + Len(RELEASE_CHECK2)	
	
			posTwo = instr( posOne, htmlResult, RELEASE_END)
	
			If posOne > 0 AND posTwo > posOne Then
				Item_Name = right(mid( htmlResult, posOne, posTwo-posOne ), posTwo-posOne)
				Item_Name = ReplaceHTML(Item_Name)
			End if
	
			' new start position
			startPos = posTwo

			'GENRE
			If Show_Genre > 0 Then                                                                      
				posOne = instr( startPos, htmlResult, GENRE_CHECK)                                  
       				posOne = instr( posOne, htmlResult, GENRE_CHECK2) + Len(GENRE_CHECK2)	          
		                                                                                                  
				posTwo = instr( posOne, htmlResult, GENRE_END)                                
		                                                                                                  
				If posOne > 0 AND posTwo > posOne Then                                            
					Item_Genre = right(mid( htmlResult, posOne, posTwo-posOne ), posTwo-posOne) 
				End if                                                                            

				' new start position                                                              
				startPos = posTwo                                                                 
	                End If

	
			'RELEASER
			If Show_Releaser > 0 Then                                                                        
				
				posOne = instr( startPos, htmlResult, RELEASER_CHECK)                                  
       				posOne = instr( posOne, htmlResult, RELEASER_CHECK2) + Len(RELEASER_CHECK2)	          
		                                                                                                  
				posTwo = instr( posOne, htmlResult, RELEASER_END)                                
		                                                                                                  
				If posOne > 0 AND posTwo > posOne Then                                            
					Item_Releaser = right(mid( htmlResult, posOne, posTwo-posOne ), posTwo-posOne) 
				End if                                                                            
		                                                                                                  
				' new start position                                                              
				startPos = posTwo                                                                 
				
				LINE_CHECK = RELEASER_CHECK
			Else
				LINE_CHECK = RELEASE_CHECK
			End If

			
	
	                ' == Build output ==



	                
	                'DATE
	                If Show_Date > 0 Then
	                	output = output & Item_Date

		                If Show_Amount_of_CDs > 0 Then
		                	output = output & " - "
		                Else 
		                	output = output & " : "
		                End If

			End If
           
	                'CDS
	                If Show_Amount_of_CDs > 0 Then
	                	output = output & Item_CDs & " CD(s) : "
	                End If


	                
	                'RELEASE
	                output = output & Item_Name

	                'GENRE
	                If Show_Genre > 0 Then
	                	output = output & " [ " & Item_Genre & " ]"

			End If

	                'TYPE
	                If Show_Type > 0 Then
				output = output & " [ " & Item_Type & " ]"
			End If
	                
	                'RELEASER
	                If Show_Releaser > 0 Then
	                	output = output & " [ " & Item_Releaser & " ]"
	                End If		                


			' don't add a newline to the last item
			If instr(startPos, htmlResult, LINE_CHECK)>0 Then
				output = output & (Chr(13) & Chr(10))
			End If
			
			Number_of_lines = Number_of_lines - 1

		Wend

		GetInfo = TrimHTML(output)
	Else
		GetInfo = "Could not obtain data."
	End if

End Function

Private Function ReturnHTML(sURL)

	Dim objXMLHTTP,HTML
	Set objXMLHTTP = CreateObject("Microsoft.XMLHTTP")
	objXMLHTTP.Open "GET", sURL, False
	objXMLHTTP.Send
	HTML = objXMLHTTP.responseBody
	Set objRS = CreateObject("ADODB.Recordset")
	objRS.Fields.Append "txt", 200, 45000, &H00000080
	objRS.Open
	objRS.AddNew
	objRS.Fields("txt").AppendChunk HTML
	ReturnHTML = objRS("txt").Value
	objRS.Close
	Set objRS = Nothing
	Set objXMLHTTP = Nothing
	
End Function

' ******************************
' Following function by Alderaic
' ******************************

'very simple function that will remove all html tags
Private Function TrimHTML(str)
	
	pos_deb = InStr(1, str, "<")
	
	Do Until pos_deb = 0
	    pos_fin = InStr(pos_deb, str, ">")
	    part_d = Mid(str, 1, pos_deb - 1)
	    part_f = Mid(str, pos_fin + 1, Len(str) - pos_fin)
	    str = part_d & part_f
	    pos_deb = InStr(1, str, "<")
	Loop
	
	teksti = Replace(str, "&nbsp;", "")
	teksti2 = Replace(teksti, Chr(9), "")
	teksti3 = Replace(teksti2, Chr(10), "")
	
	TrimHTML = teksti3 'str
	
End Function


Private Function ReplaceHTML(Str)

		str = replace(str, "&auml;", "")
		str = replace(str, "&uuml;", "")
		str = replace(str, "&ouml;", "")
		str = replace(str, "&Auml;", "")
		str = replace(str, "&Uuml;", "")
		str = replace(str, "&Ouml;", "")
		str = replace(str, "&szlig;", "")
		str = replace(str, "&quot;", """")
		str = replace(str, "&euro;", "")
		str = replace(str, "&pound;", "")
		str = replace(str, "&yen;", "")
		str = replace(str, "&amp;", "&")
		str = replace(str, "&lt;", "<")
		str = replace(str, "&gt;", ">")
		str = replace(str, "&iexcl;", "")
		str = replace(str, "&cent;", "")
		str = replace(str, "&curren;", "")
		str = replace(str, "&brvbar;", "")
		str = replace(str, "&sect;", "")
		str = replace(str, "&uml;", "")
		str = replace(str, "&copy;", "")
		str = replace(str, "&ordf;", "")
		str = replace(str, "&laquo;", "")
		str = replace(str, "&not;", "")
		str = replace(str, "&shy;", "")
		str = replace(str, "&reg;", "")
		str = replace(str, "&macr;", "")
		str = replace(str, "&deg;", "")
		str = replace(str, "&plusmn;", "")
		str = replace(str, "&sup2;", "")
		str = replace(str, "&sup3;", "")
		str = replace(str, "&acute;", "")
		str = replace(str, "&micro;", "")
		str = replace(str, "&para;", "")
		str = replace(str, "&middot;", "")
		str = replace(str, "&cedil;", "")
		str = replace(str, "&sup1;", "")
		str = replace(str, "&ordm;", "")
		str = replace(str, "&raquo;", "")
		str = replace(str, "&frac14;", "")
		str = replace(str, "&frac12;", "")
		str = replace(str, "&frac34;", "")
		str = replace(str, "&iquest;", "")
		str = replace(str, "&Agrave;", "")
		str = replace(str, "&Aacute;", "")
		str = replace(str, "&Acirc;", "")
		str = replace(str, "&Atilde;", "")
		str = replace(str, "&Aring;", "")
		str = replace(str, "&AElig;", "")
		str = replace(str, "&Ccedil;", "")
		str = replace(str, "&Egrave;", "")
		str = replace(str, "&Eacute;", "")
		str = replace(str, "&Ecirc;", "")
		str = replace(str, "&Euml;", "")
		str = replace(str, "&Igrave;", "")
		str = replace(str, "&Iacute;", "")
		str = replace(str, "&Icirc;", "")
		str = replace(str, "&Iuml;", "")
		str = replace(str, "&ETH;", "")
		str = replace(str, "&Ntilde;", "")
		str = replace(str, "&Ograve;", "")
		str = replace(str, "&Oacute;", "")
		str = replace(str, "&Ocirc;", "")
		str = replace(str, "&Otilde;", "")
		str = replace(str, "&times;", "")
		str = replace(str, "&Oslash;", "")
		str = replace(str, "&Ugrave;", "")
		str = replace(str, "&Uacute;", "")
		str = replace(str, "&Ucirc;", "")
		str = replace(str, "&Yacute;", "")
		str = replace(str, "&THORN;", "")
		str = replace(str, "&agrave;", "")
		str = replace(str, "&aacute;", "")
		str = replace(str, "&acirc;", "")
		str = replace(str, "&atilde;", "")
		str = replace(str, "&aring;", "")
		str = replace(str, "&aelig;", "")
		str = replace(str, "&ccedil;", "")
		str = replace(str, "&egrave;", "")
		str = replace(str, "&eacute;", "")
		str = replace(str, "&ecirc;", "")
		str = replace(str, "&euml;", "")
		str = replace(str, "&igrave;", "")
		str = replace(str, "&iacute;", "")
		str = replace(str, "&icirc;", "")
		str = replace(str, "&iuml;", "")
		str = replace(str, "&eth;", "")
		str = replace(str, "&ntilde;", "")
		str = replace(str, "&ograve;", "")
		str = replace(str, "&oacute;", "")
		str = replace(str, "&ocirc;", "")
		str = replace(str, "&divide;", "")
		str = replace(str, "&oslash;", "")
		str = replace(str, "&ugrave;", "")
		str = replace(str, "&uacute;", "")
		str = replace(str, "&ucirc;", "")
		str = replace(str, "&yacute;", "")
		str = replace(str, "&thorn;", "")
		str = replace(str, "&yuml;", "")
		
		ReplaceHTML = Str
		
End Function